#!/usr/bin/scsh \
-lel tinyclos/load.scm -o tiny-clos -s
!#

;;; A very simple tiny-CLOS example
;; Emilio Lopes <eclig@gmx.net>


(define mylen (make-generic))

(define mylen/str
  (make-method (list <string>)
    (lambda (cnm str)
      (string-length str))))

(add-method mylen mylen/str)
;; (mylen "foobar")
;; => 6

;; (mylen '(a b c))
;; => Error: No applicable methods/next methods.

(define mylen/pair
  (make-method (list <pair>)
    (lambda (cnm pair)
      (length pair))))
(add-method mylen mylen/pair)
;; (mylen '(a b c d))
;; => 4


(define <person> (make-class (list <object>) (list 'name 'age)))

(define (person? obj)
  (eq? <person> (class-of obj)))

(add-method initialize
  (make-method (list <person>)
    (lambda (cnm obj initargs)
      (slot-set! obj 'name (car initargs))
      (if (not (null? (cdr initargs)))
          (slot-set! obj 'age (cadr initargs))))))

(define friend1 (make <person> "Sam"))
(slot-ref friend1 'name)
(slot-ref friend1 'age)

(person? friend1)
(person? 2)
(person? "foo")

(define friend2 (make <person> "Jeff" 25))
(slot-ref friend2 'name)
(slot-ref friend2 'age)

(eq? (class-of friend1) (class-of friend2))

(class-direct-slots (class-of friend2))
